

const string LAW_OF_RESIST_VARNAME   = "PRC_LawOfResistance";
const string LAW_OF_SEQUENCE_VARNAME = "PRC_LawOfSequence";
const string TRUE_IGNORE_SR          = "PRC_True_IgnoreSR";
const string TRUE_SPEAK_UNTO_MASSES  = "PRC_True_SpeakMass";
const int    LEXICON_EVOLVING_MIND   = 1;
const int    LEXICON_CRAFTED_TOOL    = 2;
const int    LEXICON_PERFECTED_MAP   = 3;
const int    LEXICON_MIN_VALUE       = 1;
const int    LEXICON_MAX_VALUE       = 3;

//Real Utterance SpellId Constants
//Reverse Utterances are denoted with a _R

// Level 1 Utterances
const int UTTER_DEFENSIVE_EDGE         = 3526;
const int UTTER_DEFENSIVE_EDGE_R       = 3527;
const int UTTER_INERTIAL_SURGE         = 3528;
const int UTTER_INERTIAL_SURGE_R       = 3529;
const int UTTER_KNIGHTS_PUISSANCE      = 3530;
const int UTTER_KNIGHTS_PUISSANCE_R    = 3531;
const int UTTER_UNIVERSAL_APTITUDE     = 3532;
const int UTTER_UNIVERSAL_APTITUDE_R   = 3533;
const int UTTER_WORD_NURTURING_MINOR   = 3534;
const int UTTER_WORD_NURTURING_MINOR_R = 3535;
const int UTTER_FORTIFY_ARMOUR_SNEAK   = 3536;
const int UTTER_FORTIFY_ARMOUR_CRIT    = 3537;
const int UTTER_KEEN_WEAPON            = 3538;
const int UTTER_FOG_VOID_CLOUD         = 3539;
const int UTTER_FOG_VOID_SOLID         = 3540;
const int UTTER_SHIELD_LANDSCAPE       = 3541;
const int UTTER_SHOCKWAVE              = 3542;

// Level 2 Utterances
const int UTTER_ARCHERS_EYE              = 3543;
const int UTTER_ARCHERS_EYE_R            = 3544;
const int UTTER_HIDDEN_TRUTH             = 3545;
const int UTTER_HIDDEN_TRUTH_R           = 3546;
const int UTTER_PERCEIVE_UNSEEN          = 3547;
const int UTTER_PERCEIVE_UNSEEN_R        = 3548;
const int UTTER_SILENT_CASTER            = 3549;
const int UTTER_SILENT_CASTER_R          = 3550;
const int UTTER_SPEED_ZEPHYR             = 3551;
const int UTTER_SPEED_ZEPHYR_R           = 3352;
const int UTTER_STRIKE_MIGHT             = 3553;
const int UTTER_STRIKE_MIGHT_R           = 3554;
const int UTTER_TEMPORAL_TWIST           = 3555;
const int UTTER_TEMPORAL_TWIST_R         = 3556;
const int UTTER_WORD_NURTURING_LESSER    = 3557;
const int UTTER_WORD_NURTURING_LESSER_R  = 3558;
const int UTTER_AGITATE_ITEM_HOT         = 3559;
const int UTTER_AGITATE_ITEM_COLD        = 3560;
const int UTTER_ANALYZE_ITEM             = 3561;
const int UTTER_ENERGY_VORTEX_ACID       = 3562;
const int UTTER_ENERGY_VORTEX_COLD       = 3563;
const int UTTER_ENERGY_VORTEX_ELEC       = 3564;
const int UTTER_ENERGY_VORTEX_FIRE       = 3565;
const int UTTER_SPEAK_ROCK_MUD           = 3566;
const int UTTER_TRANSFORM_LANDSCAPE      = 3567;

// Level 3 Utterances
const int UTTER_ACCELERATED_ATTACK         = 3568;
const int UTTER_ACCELERATED_ATTACK_R       = 3569;
const int UTTER_ENERGY_NEGATION            = 3570;
const int UTTER_ENERGY_NEGATION_R          = 3571;
const int UTTER_ENERGY_NEGATION_CHOICE     = 3290;
const int UTTER_INCARNATION_ANGELS         = 3572;
const int UTTER_INCARNATION_ANGELS_R       = 3573;
const int UTTER_SPEED_ZEPHYR_GREATER       = 3574;
const int UTTER_SPEED_ZEPHYR_GREATER_R     = 3575;
const int UTTER_TEMPORAL_SPIRAL            = 3576;
const int UTTER_TEMPORAL_SPIRAL_R          = 3577;
const int UTTER_VISION_SHARPENED           = 3578;
const int UTTER_VISION_SHARPENED_R         = 3579;
const int UTTER_WORD_NURTURING_MODERATE    = 3580;
const int UTTER_WORD_NURTURING_MODERATE_R  = 3581;
const int UTTER_REMOVE_ITEM                = 3582;
const int UTTER_SUPPRESS_WEAPON            = 3583;
const int UTTER_LORE_WORLD                 = 3584;
const int UTTER_MASTER_FOUR_WINDS          = 3585;
const int UTTER_THWART_TRAVELER            = 3586;

// Level 4 Utterances
const int UTTER_BREATH_CLEANSING         = 3587;
const int UTTER_BREATH_CLEANSING_R       = 3588;
const int UTTER_CASTER_LENS              = 3589;
const int UTTER_CASTER_LENS_R            = 3590;
const int UTTER_CONFOUNDING_RESISTANCE   = 3591;
const int UTTER_CONFOUNDING_RESISTANCE_R = 3592;
const int UTTER_MORALE_BOOST             = 3593;
const int UTTER_MORALE_BOOST_R           = 3594;
const int UTTER_MAGICAL_CONTRACTION      = 3595;
const int UTTER_MAGICAL_CONTRACTION_R    = 3596;
const int UTTER_SPELL_REBIRTH            = 3597;
const int UTTER_SPELL_REBIRTH_R          = 3598;
const int UTTER_WORD_NURTURING_POTENT    = 3599;
const int UTTER_WORD_NURTURING_POTENT_R  = 3600;
const int UTTER_WORD_BOLSTERING          = 3601;
const int UTTER_WORD_BOLSTERING_R        = 3602;
const int UTTER_WORD_BOLSTERING_CHOICE   = 3335;
const int UTTER_SUPPRESS_ITEM            = 3603;
const int UTTER_TRANSMUTE_WEAPON         = 3604;
const int UTTER_ANGER_SLEEPING_EARTH     = 3605;
const int UTTER_CONJUNCTIVE_GATE         = 3606;
const int UTTER_DENY_PASSAGE             = 3607;

// Level 5 Utterances
const int UTTER_ELDRITCH_ATTRACTION            = 3608;
const int UTTER_ELDRITCH_ATTRACTION_R          = 3609;
const int UTTER_ENERGY_NEGATION_GREATER        = 3610;
const int UTTER_ENERGY_NEGATION_GREATER_R      = 3611;
const int UTTER_ENERGY_NEGATION_GREATER_CHOICE = 3347;
const int UTTER_ESSENCE_LIFESPARK              = 3612;
const int UTTER_ESSENCE_LIFESPARK_R            = 3613;
const int UTTER_PRETERNATURAL_CLARITY_ATTACK   = 3614;
const int UTTER_PRETERNATURAL_CLARITY_SKILL    = 3615;
const int UTTER_PRETERNATURAL_CLARITY_SAVE     = 3616;
const int UTTER_PRETERNATURAL_CLARITY_R        = 3617;
const int UTTER_SENSORY_FOCUS                  = 3618;
const int UTTER_SENSORY_FOCUS_R                = 3619;
const int UTTER_WARD_PEACE                     = 3620;
const int UTTER_WARD_PEACE_R                   = 3621;
const int UTTER_WORD_NURTURING_CRITICAL        = 3622;
const int UTTER_WORD_NURTURING_CRITICAL_R      = 3623;
const int UTTER_METAMAGIC_CATALYST_EMP         = 3624;
const int UTTER_METAMAGIC_CATALYST_EXT         = 3625;
const int UTTER_METAMAGIC_CATALYST_MAX         = 3626;
const int UTTER_SEIZE_ITEM                     = 3627;

// Level 6 Utterances
const int UTTER_BREATH_RECOVERY             = 3628;
const int UTTER_BREATH_RECOVERY_R           = 3629;
const int UTTER_ETHER_REFORGED              = 3630;
const int UTTER_ETHER_REFORGED_R            = 3631;
const int UTTER_KNIGHTS_PUISSANCE_GREATER   = 3632;
const int UTTER_KNIGHTS_PUISSANCE_GREATER_R = 3633;
const int UTTER_MYSTIC_RAMPART              = 3634;
const int UTTER_MYSTIC_RAMPART_R            = 3635;
const int UTTER_SINGULAR_MIND               = 3636;
const int UTTER_SINGULAR_MIND_R             = 3637;
const int UTTER_WORD_NURTURING_GREATER      = 3638;
const int UTTER_WORD_NURTURING_GREATER_R    = 3639;

// Syllables
const int SYLLABLE_DETACHMENT          = 3418;
const int SYLLABLE_AFFLICATION_SIGHT   = 3420;
const int SYLLABLE_AFFLICATION_SOUND   = 3421;
const int SYLLABLE_AFFLICATION_TOUCH   = 3422;
const int SYLLABLE_EXILE               = 3423;
const int SYLLABLE_DISSOLUTION         = 3424;
const int SYLLABLE_ENERVATION          = 3425;

// Truenamer
const int TRUE_SEE_THE_NAMED          = 3415;

// Brimstone Speaker
const int BRIMSTONE_FIRE_3D6       = 3426;
const int BRIMSTONE_FIRE_5D6       = 3427;
const int BRIMSTONE_FIRE_8D6       = 3428;
const int BRIMSTONE_HEAVEN_LESSER  = 3429;
const int BRIMSTONE_HEAVEN_NORMAL  = 3430;
const int BRIMSTONE_HEAVEN_GREATER = 3431;

// Crafted Tool Target Constants
const int CRAFTED_TOOL_QUICKSLOT1  = 3411;
const int CRAFTED_TOOL_QUICKSLOT2  = 3412;
const int CRAFTED_TOOL_QUICKSLOT3  = 3413;
const int CRAFTED_TOOL_QUICKSLOT4  = 3414;

// AoE Constants for Perfected Map
const int AOE_PER_FOG_VOID_CLOUD      = 142;
const int AOE_PER_FOG_VOID_SOLID      = 143;
const int AOE_PER_SHIELD_LANDSCAPE    = 144;
const int AOE_PER_ENERGY_VORTEX       = 145;
const int AOE_PER_SPEAK_ROCK_MUD      = 146;
const int AOE_PER_TRANSFORM_LANDSCAPE = 147;
const int AOE_PER_DENY_PASSAGE        = 148;